%% SatNOGS COMMS System Design Document - Requirements Tables
%% Copyright (C) 2021, 2022 Libre Space Foundation
%%
%% This work is licensed under a
%% Creative Commons Attribution-ShareAlike 4.0 International License.
%%
%% You should have received a copy of the license along with this
%% work.  If not, see <http://creativecommons.org/licenses/by-sa/4.0/>.

{% set types = [
  'Configuration',
  'Design',
  'Environmental',
  'Functional',
  'Interface',
  'Logistics Support',
  'Operational',
  'Performance',
  'Product Assurance',
  'Verification',
]
%}
{%- set compliance = [
  'Compliance::Full',
  'Compliance::Partial',
  'Compliance::None',
  'Compliance::Not Applicable',
]
%}

\providecommand{\tightlist}{
\setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}

{% for type in types %}
\newcommand{\{{ type | replace(' ', '') }}}{
{% for item in issues if type in item.labels %}
\begin{table}[ht]
  \centering
  \begin{tabular}{lp{0.6\linewidth}}
    \toprule
    \textbf{ID} &
         \bfseries
         REQ-{{ item.id }} --- {{ item.title | md2tex }}
    \\ \midrule
    \textbf{Type} & {{ item.labels|select('in', types)|join(', ') }} \\ \midrule
    \textbf{Description} &
         {{ item.content.Description | md2tex }}
    \\ \midrule
    \textbf{Rationale} &
         {{ item.content.Rationale | md2tex }}
    \\ \bottomrule
  \end{tabular}
\end{table}
{% endfor %}
}
{% endfor %}

\newcommand{\reqmatrix}{
{%- for item in issues %}
  \reqcomprec{{ '{' }}{{item.id}}}{{ '{' }}{{ item.labels | select('in', compliance) | first | replace('Compliance::', '') }}}{{ '{' }}{{ item.content['Design Compliance Comment'] }}}
  \\ {% if not loop.last %}\midrule{% else %}\bottomrule{% endif %}
{%- endfor %}
}
